%  QPBOI
M=100;
N=100;
sigma = 0.2;
I = sqrt(-1);
 
varphi=gaussele(M,N,14*pi,10*M/100,15*N/100); 
varphi(1:M/2,1:N/2) = 0;
% [X,Y] = meshgrid(0:N-1,0:M-1);
% mask = X<=Y+20;
% varphi = varphi.*mask;

% varphi =pi/4*cumsum(ones(M,N));
% varphi(:,1:N/2) = 0;
% varphi = varphi/(max(varphi(:))-min(varphi(:)))*12*pi;

% file = fopen('data/longs.152x458.phase');
% B = fread(file);
% varphi = reshape(B,152,458);
% varphi = -pi+varphi/256*2*pi;
% % varphi = varphi(1:140,1:140);
% [M,N] = size(varphi);

% S=2055615866; randn('seed', S);
% varphi=randn(M,N);
% fc = 0.05; % define cut frequency
% mask = zeros(M,N);
% mask(round(M/2-fc*M/2):round(M/2+fc*M/2), ...
%      round(N/2-fc*N/2):round(N/2+fc*N/2)) = 1; 
% varphi =  240* real(ifft2(fftshift(fftshift(fft2(varphi)).*mask)));
% varphi = varphi/(max(varphi(:))-min(varphi(:)))*12*pi;

% load spiral.surf.mat
% varphi = spiral;
% clear spiral;
% [M,N] = size(varphi);


% generate noise
S=2055615866; randn('seed', S);
noise = sigma*(randn(M,N)+I*randn(M,N));
% generate observed data
z = exp(I*varphi)+ noise;
% compute the interferogram;
phi = angle(z);



% QPBOI processing
p=0.5; % Clique potential exponent
figure;
tic;
[unwph,iter,erglistI] = QPBOI(phi,p);
toc

% potential.quantized = 'no';
% potential.threshold = 0.3;
% schedule = [1 2 3 4 5];tic;
% [unwph,iter,erglistI]=QPBOI(phi,0.001,'potential',potential,'schedule',schedule);toc

figure;
surfl(unwph);shading interp; colormap(gray);
%title('QPBOI solution');


