load('phi_hat_denoise.mat');
load('mask1.mat');
load('masks.mat');
load('ccorr.mat');
unwrap_phase = zeros(size(phi_hat_SpInPHASE));
baseall = mask1.*ccorr;

tic;
step = 400;
for ii = 1:4800/step
    for jj = 1:2400/step
        xrange = ((ii-1)*step+1):(ii*step);
        yrange = ((jj-1)*step+1):(jj*step);
        dxrange = max(((ii-1)*step+1)-50,1):min((ii*step)+50,4800);
        dyrange = max(((jj-1)*step+1)-50,1):min((jj*step)+50,2400);
       
        base = baseall(dxrange,dyrange);
        qualmap = repmat(1-ccorr(dxrange,dyrange),[1,1,2]);
        potential.quantized = 'no';
        potential.threshold = 2;
        unwrap_phasetemp = QPBOI(phi_hat_SpInPHASE(dxrange,dyrange),2,'potential',potential,'qualitymaps', qualmap,'base',base);

        is = 51;ie = step+50;
        js = 51;je = step+50;
        if ii == 1 
            is = 1;ie = step;
        end
        if jj==1
            js = 1;je = step;
        end
        
        all = 0;
        num = 0;
        if ii>1
            tt1 = unwrap_phase(((ii-1)*step-50):((ii-1)*step-1),yrange);
            ett1 = unwrap_phasetemp(1:50,js:je); 
            mmask = mask1(((ii-1)*step-50):((ii-1)*step-1),yrange);
            all = all+sum((ett1(:)-tt1(:)).*mmask(:));
            num = num+sum(mmask(:));
%             num = num+length(ett1(:));
        end
        if jj>1
            tt2 = unwrap_phase(xrange,((jj-1)*step-50):((jj-1)*step-1));
            ett2 = unwrap_phasetemp(is:ie,1:50);
            mmask2 = mask1(xrange,((jj-1)*step-50):((jj-1)*step-1));
            all = all+sum((ett2(:)-tt2(:)).*mmask2(:));
            num = num+sum(mmask2(:));
%             num = num+length(ett2(:));
        end
        if num~=0
            unwrap_phasetemp = unwrap_phasetemp-2*pi*round(all/num/(2*pi));
        end
        
        unwrap_phase(xrange,yrange) = unwrap_phasetemp(is:ie,js:je);
        

    end
end

qualmap = repmat(1-ccorr(2400:4800,500:1600),[1,1,2]);
base = baseall(2400:4800,500:1600);
potential.quantized = 'yes';
potential.threshold = 2;
unwrap_phasetemp = QPBOI(phi_hat_SpInPHASE(2400:4800,500:1600),2,'potential',potential,'qualitymaps', qualmap,'base',base);

tt1 = unwrap_phase(2400:2449,500:1600);
ett1 = unwrap_phasetemp(1:50,:);        
nn = sum(ett1(:)-tt1(:))/2/pi/numel(ett1);
unwrap_phasetemp = unwrap_phasetemp-round(nn)*2*pi;
unwrap_phase(2400:4800,500:1600) = unwrap_phasetemp;  

for ii = 7:4800/step
    for jj = 5:2400/step
        xrange = ((ii-1)*step+1):(ii*step);
        yrange = ((jj-1)*step+1):(jj*step);
        dxrange = max(((ii-1)*step+1)-50,1):min((ii*step)+50,4800);
        dyrange = max(((jj-1)*step+1)-50,1):min((jj*step)+50,2400);
       
        base = baseall(dxrange,dyrange);
        qualmap = repmat(1-ccorr(dxrange,dyrange),[1,1,2]);
        potential.quantized = 'no';
        potential.threshold = 2;
        unwrap_phasetemp = QPBOI(phi_hat_SpInPHASE(dxrange,dyrange),2,'potential',potential,'qualitymaps', qualmap,'base',base);

        is = 51;ie = step+50;
        js = 51;je = step+50;
        if ii == 1 
            is = 1;ie = step;
        end
        if jj==1
            js = 1;je = step;
        end
        
        all = 0;
        num = 0;
        if ii>1
            tt1 = unwrap_phase(((ii-1)*step-50):((ii-1)*step-1),yrange);
            ett1 = unwrap_phasetemp(1:50,js:je); 
            mmask = mask1(((ii-1)*step-50):((ii-1)*step-1),yrange);
            all = all+sum((ett1(:)-tt1(:)).*mmask(:));
            num = num+sum(mmask(:));
%             num = num+length(ett1(:));
        end
        if jj>1
            tt2 = unwrap_phase(xrange,((jj-1)*step-50):((jj-1)*step-1));
            ett2 = unwrap_phasetemp(is:ie,1:50);
            mmask2 = mask1(xrange,((jj-1)*step-50):((jj-1)*step-1));
            all = all+sum((ett2(:)-tt2(:)).*mmask2(:));
            num = num+sum(mmask2(:));
%             num = num+length(ett2(:));
        end
        if num~=0
            unwrap_phasetemp = unwrap_phasetemp-2*pi*round(all/num/(2*pi));
        end
        
        unwrap_phase(xrange,yrange) = unwrap_phasetemp(is:ie,js:je);
        

    end
end
toc


save('phi_hat_unwrap','unwrap_phase');
figure(1);colormap gray;imagesc(unwrap_phase.*mask1.*ccorr);
        
        